import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A Mover is an actor that also has 'move' and 'turn' ability. Both moving and turning 
 * are relative to its current position. When moving, the Mover will move in the direction 
 * it is currently facing.
 * 
 * Both 'move' and 'turn' methods are available with or without parameters.
 * 
 * The 'Mover' class is a subclass of Actor. It can be used by creating subclasses, or
 * copied into scenarios and edited inline.
 * 
 * The initial direction is to the right. Thus, this class works best with images that
 * face right when not rotated.
 * 
 * This class can also check whether we are close to the edge of the world.
 * 
 * @author Michael Kolling
 * @version 1.0 (July 2007)
 */
public class Mover extends Actor
{
    private static final double WALKING_SPEED = 2.0;
        
    private boolean ban = true;
private boolean ban2 = true;
private int speed = 0;
    private int accel = 1;
      int jump = 18;
    
    /**
     * Turn 90 degrees to the right (clockwise).
     */
   
    /**
     * Move a bit forward in the current direction.
     */
    public void move()
    {
        move(WALKING_SPEED);
    }

    
    /**
     * Move a specified distance forward in the current direction.
     */
    public void move(double distance)
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * distance);
        int y = (int) Math.round(getY() + Math.sin(angle) * distance);
        
        setLocation(x, y);
    }
    
     public void mueve()
    {
     World mundo = getWorld(); //acceder al mundo
        int ancho = mundo.getWidth();//Nos da el ancho;
        int alto = mundo.getHeight();//nos da el alto;
       
        GreenfootImage imagen = getImage();
        int width = imagen.getWidth();
        int height = imagen.getHeight();
      
   
        if(getY() - height/2 >= 0 && getFlag() && getFlag2())
        {
              setLocation(getX()-1, getY()-1);
              setImage("fantasma4.png");
            }
        else if(getX() - width/3 >= 0 && !getFlag() && getFlag2())
        {      
        setLocation(getX()-1, getY()+1);
             setImage("fantasma4.png");
        }
        else if(getY() + height/2 <= alto && !getFlag() && !getFlag2())
        {
        setLocation(getX()+1,getY()+1);
            setImage("fantasma4regreso.png");
        }
        else if(getX() + width/3 <= ancho && getFlag() && !getFlag2())
        {
        setLocation(getX() +1, getY()-1);
         setImage("fantasma4regreso.png");
        }      
        if(getY() - height/2 == 0 ) 
             
              setFlag(false);
              
        if(getX() - width/3 == 0 )
              setFlag2(false);
              
        if(getY() + height/2 == alto )
              setFlag(true);
        
        if(getX() + width/3 == ancho )
              setFlag2(true);
    }



    public boolean getFlag()
{
return ban;
}

public boolean getFlag2()
{
   return ban2;
}

public void setFlag(boolean x)
{
ban = x;
}
public void setFlag2(boolean x)
{
   ban2 = x;
}

public void setDir()
{
    if(ban)
       ban = false;
    else
       ban = true;
}

 /**
      * Checks if the ghost is falling
      */
     public void fall() // esta cayendo 
    {
      setLocation(getX(), getY() + speed);   // como esta cayendo,, se le suma a la coordenada y la velocidad de caida para que llegue al suelo
      speed = speed + accel;  
     }
     
    /**
    * Checa si esta cayendo
    */
    public void checkFall()
    {
     if(onGround()) // si esta sobre piso,, la velocidad es cero                
    {
     speed = 0;
    }
    else                    
    {
    fall(); // si no kiere decir ke esta cayendo
    }
   }
   
  /**
  * Identifies if the character is on ground
  */
   public boolean onGround()
   {
    Actor b = getOneObjectAtOffset( 0, getImage().getHeight()/2, Floor.class); // obtiene los obejtos con respecto del personaje, y retorna diferente de null cuando no los enceuntra
   return b != null;
  }
  
   public void jump()
   {
    
    speed = -jump;
    
    fall(); // gravity counteracts jumpStrength
   }
  
}
    